#!/bin/bash
#
# pre-dator.sh by SlaSk and Noctural
# 
# ***READ THE HOWTO***
#
#
# 2.03.0(1)-release - bash  http://sunsite.unc.edu/pub/gnu/bash
# grep (GNU grep) 2.1 - fgrep


# Edit these settings to suite your needs.

# Number of groups
count=3
SNL="iNTERNET pROTOCOL"
# One line per group that may pre.
# Format "<group>:<dir group may pre from>:<username in log>:<group in log>:<unfo in log>"

# Example:
data[0]="iPA:/site/private/iPA:iPA-PRE:iPA:iPA Pre Whore"
data[1]="WaR:/site/private/WaR:WaR-PRE:WaR:WaR PRE MACHINE"
data[2]="ElilA:/site/private/EllilA:ElilA-PRE:ElilA:ElilA PRE MACHINE"

#data[0]="iPA:/site/Pre/IPA:iPA-PRE:iPA:iPA Pre Whore"
#data[1]="ECLIPSE:/site/ECLIPSE:ECL-PRE:ECLIPSE:ECLIPSE PRe MaCHiNe"
#data[2]="STAFF:/site:STAFF:STAFF:STAFF member prolly screwing something up..."

tagline=`grep UNFO /ftp-data/users/$USER |sed s/"UNFO "//`
AnnounceFile="/ftp-data/logs/glftpd.log"
RelSize=`/bin/relsize $1`
Disks=`/bin/ls $PWD/$1/*.zip | wc -l | /bin/cut -b6- | awk '{print $1}'`
# -- Dont edit below here or u'll prolly mess shit up --


echo "(iP) iP Pre SysTem (iP)"
echo

log_file=/ftp-data/logs/glftpd.log
today_dir=/site/Today
user_data_dir=/ftp-data/users

if [ -z "$1" ] ; then
	echo "(iP) Usage: SITE PRE <dir> (iP)"
	exit
fi

if [ ! -e $user_data_dir/$USER ] ; then
    echo "(iP) Couldn't find userdata for $USER (iP)"
    exit
fi

groups=`fgrep "GROUP
PRIVATE" $user_data_dir/$USER | awk '{ print $2 }'`

group_match_flag=0

i=0
while [ $i -lt $count ] ; do

	group=`echo ${data[$i]} | awk -F : '{ print $1 }'`
	dir=`echo ${data[$i]} | awk -F : '{ print $2 }'`
	user=`echo ${data[$i]} | awk -F : '{ print $3 }'`
	grp=`echo ${data[$i]} | awk -F : '{ print $4 }'`
	unfo=`echo ${data[$i]} | awk -F : '{ print $5 }'`

	if [ -n "`echo -n $groups | fgrep $group`" ] ; then
		echo "(iP) Group Check Successfull! Proceed with PRE.. (iP)"
		group_match_flag=1
		if [ -n "`echo $PWD | fgrep $dir`" ] ; then
		if [ -e "$PWD/$1" ] ; then
			if [ -e "$today_dir/$1" ] ; then
				echo -n "(iP)You are not allowed to pre to the existing directory (iP)"
				echo `ls -l $today_dir | awk -F / '{ print $NF }'`/$1
				exit
			fi
			cp -R "$PWD/$1" "$today_dir"
			rm -r $PWD/$1
#			echo `date "+%a %b %d %T %Y"`
#NEWDIR: \"$today_dir/$1\" \"$user\" \"$grp\" \"$unfo\" >> $log_file
echo "`/bin/date \"+%a %b %d %T %Y\"` PRE: \"$PWD/$1\" \"$Disks\" \"$RelSize\" \"$GROUP\" \"$SNL\"" >> $log_file
echo "(iP) PRE Completed Successfully (iP)"
			exit
		else
			echo "Usage: SITE PRE <dir>"
			exit
		fi
		fi
	fi
	i=$[i + 1]
done

if [ $group_match_flag -eq 1 ] ; then
    echo "(iP) You are not allowed to pre from this directory.(iP)"
    exit
fi

echo "(iP) You are not allowed to use this command!(iP)"
